import pygame
import random
from player import Player

class Game:
    def __init__(self, screen):
        self.screen = screen
        self.running = True
        self.clock = pygame.time.Clock()
        self.ball = Player(60, 60)
        self.background = pygame.image.load("asset/background.jpg")
        self.brique = pygame.image.load("asset/brique.jpg")
        self.brique_rects = []
        self.brique_positions = []
        self.brique_speed = 3
        self.brique_spawn_rate = 120
        self.brique_spawn_counter = 0
        self.brique_spawn_augmentation = 15
        self.brique_spawn_increase_counter = 0
        self.total_time = 0
        self.total_time_max = 0
        self.difficulté = 20
        pygame.mouse.set_visible(False)
    
        choix = input("_____________________________________________________________________________ \n choisissez votre difficulté : \n 1- Facile \n 2- Normal \n 3- Difficile \n _____________________________________________________________________________ \n Votre choix : ")
        choix = int(choix)
        if choix == 1:
            self.difficulté = 1
        elif choix == 2:
            self.difficulté = 5
        elif choix == 3:
            self.difficulté = 10
        else:
            print("Error : s'il vous plait entré un entier positif entre 1 et 3")
            self.running = False

    def gestion_events(self):
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                self.running = False

        self.ball.move(pygame.mouse.get_pos())

    def adaptative_brique_rects(self):
        self.brique_rects = []

        for pos in self.brique_positions:
            rect = pygame.Rect(pos[0], pos[1], self.brique.get_width(), self.brique.get_height())
            self.brique_rects.append(rect)

    def spawn_brique(self):
        y = random.randint(0, self.screen.get_height() - self.brique.get_height())
        self.brique_positions.append((-self.brique.get_width(), y))

    def move_briques(self):
        for i in range(len(self.brique_positions)):
            pos = list(self.brique_positions[i])
            pos[0] += self.brique_speed
            self.brique_positions[i] = tuple(pos)

        self.adaptative_brique_rects()

    def update(self):
        self.brique_spawn_counter += self.difficulté

        if self.brique_spawn_counter % 120 == 0:
            self.brique_speed += 0.2

        self.brique_spawn_increase_counter += 1
        if self.brique_spawn_increase_counter >= self.brique_spawn_augmentation * 60:
            self.brique_spawn_increase_counter = 0
            self.brique_spawn_rate -= 10

        if self.brique_spawn_counter >= self.brique_spawn_rate:
            self.brique_spawn_counter = 0
            self.spawn_brique()

        self.move_briques()
        self.total_time += 1  

        for rect in self.brique_rects:
            if rect.colliderect(self.ball.rect):
                print("_____________________________________________________________________________\n")
                print("    Vous avez perdu, Votre temps est de", self.total_time/100, "secondes, bien joué à vous ;)")
                print("_____________________________________________________________________________\n")
                self.running = False
                break
            else:
                pass
        
    def display(self):
        self.screen.blit(self.background, (-200, -350))
        for pos in self.brique_positions:
            self.screen.blit(self.brique, pos)
        self.ball.draw(self.screen)
        pygame.display.flip()

    def run(self):
        while self.running:
            self.gestion_events()
            self.update()
            self.display()
            self.clock.tick(60)
        pygame.mouse.set_visible(True)
        pygame.quit()

pygame.init()
screen = pygame.display.set_mode((1080, 720))
game = Game(screen)
game.run()

pygame.quit()